%clear variables
global alpha beta

alpha=3.37207
beta=2;


 m=45; %number of modes for the Floquet Normal form   
 dim_man=1


%Manifold Parameters
stability=input('Please choose the stability of the manifold: S stable, U unstable ','s');
'SCALE EINGENVALUES = NO'
scaleEigs=1;

N_manifold=10;
m_manifold=66;

D2=[0,0,0; 0,0,0;-1,1,1];

mode='2T'





load Num_sol_Arneodo



X0=Num_sol_Arneodo(1:4);  %[L,a1_0,a2_0,a3_0]   L=2*pi/T
X=Num_sol_Arneodo(5:end); 
X=reshape(X,6,[]);
aold=[X0(2:end),[X(1,:);X(3,:);X(5,:)]];
bold=[ [0;0;0], [X(2,:);X(4,:);X(6,:)]];
power=13;                           % compute newton scheme up to error e^(-power)
orbit=newton_arneodo_orbit(Num_sol_Arneodo,aold,bold,power);
L=orbit(1); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% COMPUTE NUMERICAL SOLUTION FOR FLOQUET SYSTEM %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global Const gamma_0 gamma_k T

Const=[0, 1, 0;...
       0, 0, 1;...
     alpha, -beta,-1];

T=2*pi/L;                                                                % period of the orbit
gamma_0=orbit(2:4);                                                               % a0 coefficients
ABk=reshape(orbit(5:end),6,[]); 
% each column contains the real and 
%immaginary parts of the coefficients:
%[Re(xi^1_k);Im(xi^1_k);Re(xi^2_k);Im(xi^2_k);Re(xi^3_k);Im(xi^3_k))
%ak,bk coefficients of the orbit

gamma_k=ABk([1,3,5],:)+1i*ABk([2,4,6],:);
orbit=[flipdim(conj(gamma_k(:,1:end)),2),gamma_0,gamma_k];
disp('Computating the numerical solution for Floquet system');
T
if mode=='2T'    % extend gamma to a 2T periodic function
    T=2*T;
gamma_k2T=zeros(3,2*size(gamma_k,2));
gamma_k2T(:,2:2:end)=gamma_k;
gamma_k=gamma_k2T;
end

Ak=compute_Ak_Arneodo(gamma_0,gamma_k);

[B,Pk]=integration_floquet_arneodo_complex(m);

return



 
