function [B,Pk]=integration_floquet_arneodo_complex(m)

global alpha beta  gamma_0 gamma_k T 

options=odeset('AbsTol',1e-12,'RelTol',1e-8);

sol_ini=gamma_0;
sol_ini=sol_ini+2*sum(real(gamma_k),2);


M=arneodo_monodromyT;      % first guess for the monodromy
B=logm(M)/(T);

%%%%%%%%%%%%%%%%%%%%
%%%% integration of f'=Jac(gamma(t))*f-f*R, f(0)=I

inispace=sol_ini;
ini_Q=eye(3);
ini=[inispace;reshape(ini_Q,9,1)];

[t,y]=ode45(@system,[0,T],ini,options);       %integration of f'=Jac(gamma(t))*f-f*R, f(0)=I

N=length(t)-1;
Comp=fft(y(:,4:end))/N;                 % fourir coefficients

for j=1:m
    Qk(:,:,j)=reshape(Comp(j,:),3,3);
end

m=size(Qk,3)-1;
Pk=cat(3,conj(Qk(:,:,end:-1:2)),Qk);

clear Comp
function Mon=arneodo_monodromyT
        Id=eye(3);
        ini=[sol_ini;reshape(Id,[],1)];
        [t,y]=ode45(@systemMonodromyArneodo,[0 T],ini,options);   % integrate monodrmy matrix
        Mon=reshape(y(end,4:end),3,3);
        
        
        
        function df=systemMonodromyArneodo(t,x)
            
            Mon=reshape(x(4:end),3,3);
            
            
            J=[0, 1, 0;...
                0, 0, 1;...
                alpha-2*x(1),-beta,-1];
            
            
            df(1,1)=x(2);
            df(2,1)=x(3);
            df(3,1)=alpha*x(1)-x(1)^2-beta*x(2)-x(3);
            dfM=J*Mon;
            df=[df;reshape(dfM,9,1)];
            
        end
        
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    function df=system(t,x)
        
        f=reshape(x(4:end),3,3);
        
        J=[0, 1, 0;...
            0, 0, 1;...
            alpha-2*x(1),-beta,-1];
        
        df(1,1)=x(2);
        df(2,1)=x(3);
        df(3,1)=alpha*x(1)-x(1)^2-beta*x(2)-x(3);
        dff=J*f-f*B;
        df=[df;reshape(dff,9,1)];
    end
end