%clear variables

global nu T 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     %%%% USER-DEFINED VARIABLES %%%%%%%

     
cont_step = input('Starting from nu=0.127, and nu_step=-0.002, number of continuation steps\n');     
delnu = -0.002 % Step-size of the parameter in the continuation
m1 = 20;       % Number of time Fourier modes
N=10;          % number of space Fourier modes




%Manifold Parameters
mode='T';
dim_man=1;
scaleEigs=1;
stability=input('Please choose the stability of the manifold: S stable, U unstable \n ','s');
N_manifold=15;
m_manifold=15;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% COMPUTATION OF NUMERICAL PERIODIC ORBIT %%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp(' Continuation of KS periodic solutions');

[totX,totNU]=cont_periodic_KS(delnu,cont_step,m1,N);

x=totX(:,end);
m2=(length(x)-2+2*m1)/(2*m1-1);    % it should be N+1

n=2*m1*m2-2*m1-m2+2;
    A=x(2:m1*m2-m1-m2+2);
    B=x(m1*m2-m1-m2+3:n);
    a=zeros(m1-1,m2-1);
    b=zeros(m1,m2-1);

    for k2=1:m2-1
        a(:,k2)=A((k2-1)*(m1-1)+1:k2*(m1-1));
        b(:,k2)=B((k2-1)*m1+1:k2*m1);
    end
    
[n1,n2]=size(a);
m1=n1+1;
m2=n2+1;
a_temp=zeros(m1,m2);
a_temp(2:m1,2:m2)=a;
a=a_temp;

b_temp=zeros(m1,m2);
b_temp(1:m1,2:m2)=b;
b=b_temp;

c=a+1i*b;

gamma_kpos=c(:,2:end).';   %gamma_k(:,k)=xi^n_(k-1) for n=1....N, k=0...m
N=size(gamma_kpos,1);
m=size(gamma_kpos,2)-1;
gamma_0=gamma_kpos(:,1);

gamma_k=[flipdim(-conj(gamma_kpos(:,2:end)),2),gamma_kpos]; %gamma_0=gamma_k(:,m+1)
orbit=gamma_k;
T=2*pi/x(1);
nu=totNU(end);

% Second derivative coefficients
PR=[nchoosek([-N:-1,1:N],2);repmat([-N:-1,1:N].',1,2)];

D2=zeros(N,3,N-1);
for j=1:N
   ind_j=find(sum(PR,2)==j);
   label_j=PR(ind_j,:);
   coeff_j=-j*(2*ones(size(label_j,1),1)-(label_j(:,1)==label_j(:,2))); % if k_1=k_2 counts only one, else counts 2
   coeff_j=coeff_j.*sign(label_j(:,1)).*sign(label_j(:,2));
   D2(j,:,1:size(label_j,1))=reshape([coeff_j,abs(label_j)].',1,3,[]); 
end

%D2




% define the Fourier coefficiets of the functions w_n(t)=Re(x_n(t))
mu_k=-1i*gamma_k;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% COMPUTE NUMERICAL SOLUTION FOR FLOQUET SYSTEM %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Computing the numerical solution for Floquet system');
gamma_0=mu_k(:,m+1);
gamma_k=mu_k(:,m+2:end);
Ak=compute_Ak_KS(gamma_0,gamma_k);

[B,Pk]=integration_floquet_KS_complex(mu_k);
mm=10;
return










