function [calF]=cF_KS_complex(x,nu,m1,m2)

%%% m1 : size of the time Fourier expansion
%%% m2 : size of the spatial Fourier expansion

n=2*m1*m2-2*m1-m2+2;
L=x(1);
A=x(2:m1*m2-m1-m2+2);
B=x(m1*m2-m1-m2+3:n);

a=zeros(m1-1,m2-1);
b=zeros(m1,m2-1);

for k2=1:m2-1
    a(:,k2)=A((k2-1)*(m1-1)+1:k2*(m1-1));
    b(:,k2)=B((k2-1)*m1+1:k2*m1);
end

%%% Let us define the phase condition
eta=b(2,1); %%% That corresponts to fixing b_{1,1}=0

[n1,n2]=size(a);
m1=n1+1;
m2=n2+1;
a_temp=zeros(m1,m2);
a_temp(2:m1,2:m2)=a;
a=a_temp;

b_temp=zeros(m1,m2);
b_temp(1:m1,2:m2)=b;
b=b_temp;

c=a+1i*b;

[quad_term]=twoDquadratic_sumFFT_complex_KS(c);
%[quad_term]=twoDquadratic_sumFFT_complex_KSqui(c);

MU=zeros(m1,m2);
K2=zeros(m1,m2);

for k2=0:m2-1
    for k1=0:m1-1
        MU(k1+1,k2+1)=1i*k1*L-k2^2+nu*k2^4;
        K2(:,k2+1)=k2;
    end
end

h=MU.*c-1i*K2.*quad_term;

f=real(h);
g=imag(h);
f(:,1)=[];
f(1,:)=[];
g(:,1)=[];

F=zeros((m1-1)*(m2-1),1);
G=zeros(m1*(m2-1),1);

for k2=1:m2-1
    F((k2-1)*(m1-1)+1:k2*(m1-1))=f(:,k2);
    G((k2-1)*m1+1:k2*m1)=g(:,k2);
end

calF=[eta;F;G];

end

function quad=twoDquadratic_sumFFT_complex_KSqui(c)
m=size(c,1)-1;
N=size(c,2)-1;

quad=zeros(m+1,N+1);

for n=0:N
for p=-N:N
       q=n-p;
       if abs(p)<=N && abs(q)<=N
       xip=(-1+2*(p>=0))*c(:,abs(p)+1);
       xiq=(-1+2*(q>=0))*c(:,abs(q)+1);
       xip=[flipud(-conj(xip(2:end)));xip];
       xiq=[flipud(-conj(xiq(2:end)));xiq];
       
       for k=0:m
           for k1=-m:m
               k2=k-k1;
               if abs(k1)<=m && abs(k2)<=m
                   quad(k+1,n+1)=quad(k+1,n+1)+xip(m+1+k1)*xiq(m+1+k2);
               end
           end
       end
       end
   end
end
end