function [calF_nu]=cF_KS_complex_nu(x,m1,m2)

%%% m1 : size of the time Fourier expansion
%%% m2 : size of the spatial Fourier expansion

n=2*m1*m2-2*m1-m2+2;

A=x(2:m1*m2-m1-m2+2);
B=x(m1*m2-m1-m2+3:n);

a=zeros(m1-1,m2-1);
b=zeros(m1,m2-1);

for k2=1:m2-1
    a(:,k2)=A((k2-1)*(m1-1)+1:k2*(m1-1));
    b(:,k2)=B((k2-1)*m1+1:k2*m1);
end

[n1,n2]=size(a);
m1=n1+1;
m2=n2+1;
a_temp=zeros(m1,m2);
a_temp(2:m1,2:m2)=a;
a=a_temp;

b_temp=zeros(m1,m2);
b_temp(1:m1,2:m2)=b;
b=b_temp;

K2=zeros(m1,m2);

for k2=0:m2-1
    K2(:,k2+1)=k2;
end

f=K2.^4.*a;
g=K2.^4.*b;

f(:,1)=[];
f(1,:)=[];
g(:,1)=[];

F=zeros((m1-1)*(m2-1),1);
G=zeros(m1*(m2-1),1);

for k2=1:m2-1
    F((k2-1)*(m1-1)+1:k2*(m1-1))=f(:,k2);
    G((k2-1)*m1+1:k2*m1)=g(:,k2);
end

calF_nu=[0;F;G];

end