function [totX,totNU]=cont_periodic_KS(delnu,cont_step,m1,N)
    
[x,nu,m2]=x_from_time_series_KS(m1,N);

n=2*m1*m2-2*m1-m2+2;

tol=5e-14; 

totNU=nu;
totX=zeros(n,1);

for step=1:cont_step
    
    display(['Continuation step = ',num2str(step),'  Parameter value = ',num2str(nu)]);
    F = cF_KS_complex(x,nu,m1,m2);
    display(['The inf norm of F = ',num2str(norm(F,inf))])
    J=inv(finite_diff_KS_complex(x,nu,m1,m2));
    itercount=0;
    
    while (itercount<=20) && (norm(F,inf) > tol),
        x=x-J*F;                   %%% Quasi-Newton Corrector %%%
        F = cF_KS_complex(x,nu,m1,m2);
        display(['The inf norm of F = ',num2str(norm(F,inf))])
        J=inv(finite_diff_KS_complex(x,nu,m1,m2));
        itercount=itercount+1;
    end
    
    delnu=delnu*2^((4-itercount)/3);
    
    totX(:,step)=x;
    totNU(step)=nu;
    
    if norm(F,inf) > tol
        display(['failure with Newton at ',num2str(nu)])
        break
    end
    
    %%% We define the quantities for the next phase condition
    
    n=2*m1*m2-2*m1-m2+2;
    A=x(2:m1*m2-m1-m2+2);
    B=x(m1*m2-m1-m2+3:n);

    a=zeros(m1-1,m2-1);
    b=zeros(m1,m2-1);

    for k2=1:m2-1
        a(:,k2)=A((k2-1)*(m1-1)+1:k2*(m1-1));
        b(:,k2)=B((k2-1)*m1+1:k2*m1);
    end
    
    %%% We define the tangent vector 
    
    dx=-J*cF_KS_complex_nu(x,m1,m2);
    x=x+delnu*dx;
    nu=nu+delnu;
    
end   

return