function [x,nu,m2,u0_old,u_t0_old]=x_from_time_series_KS(m1,N)

load periodic_integration_KS

%%% M1 : # of time integration
%%% m1 : size of the time Fourier expansion
%%% m2 : size of the spatial Fourier expansion
%%% In the case of the periodic orbit of KS presented in the FoCM paper
%%% (2004) of Piotr Zgliczynski in Theorem 9, one has that m2 = 15 and 
%%% nu = 0.127.

nu=0.127;
%m1=20;

[M1,n2]=size(Y);
m2=n2+1;

period=T(M1);
L=2*pi/period;

C=zeros(M1,m2-1);

for k=1:m2-1
    C(:,k)=fft(1i*Y(:,k))/M1;  %%% Time Fourier expansion of the k^th spatial Fourier mode 
end

C(m1+1:end,:)=[];

% aggiunto da me
to_add=N-(m2-1);
if to_add>0
C=[C,zeros(size(C,1),to_add)];
else
    C(:,end+to_add+1:end)=[];
end
m2=size(C,2)+1;
%
a=real(C);
b=imag(C);
a(1,:)=[];

A=zeros((m1-1)*(m2-1),1);
B=zeros(m1*(m2-1),1);

for k2=1:m2-1
    A((k2-1)*(m1-1)+1:k2*(m1-1))=a(:,k2);
    B((k2-1)*m1+1:k2*m1)=b(:,k2);
end

x=[L;A;B];

%%% We define the terms involved in the phase condition

u0_old=b(1,:)+2*sum(b(2:end,:));
u_t0_old=zeros(1,m2-1);
for k2=1:m2-1
    u_t0_old(k2)=sum((1:m1-1).*a(1:m1-1,k2)');
end

%%%% Plot of the periodic Fourier coefficients

%for k=1:m2-1
%	hold on
%	time_plot_periodic(L,a(:,k),b(:,k));
%end

end