function ris=continuation_lorenz(rho_ini,vec_ini,rho_fin)

% do continuation of the periodic solution from rho_ini up to rho_fin

global rho 
rho=rho_ini;
V=vec_ini;
Mgamma=(size(V,1)+2)/6;
X0=V(1:4);                          
X=V(5:end);
X=reshape(X,6,Mgamma-1);
aold=[X0(2:end),[X(1,:);X(3,:);X(5,:)]];
bold=[ [0;0;0], [X(2,:);X(4,:);X(6,:)]];
power=11;

ris=newton_orbit_lorenz(V,aold,bold,power);

while rho~=rho_fin
    display(['Doing continuation '  'Parameter value = ',num2str(rho)]);
    
    delta=min(sign(rho_fin-rho)*min([0.1,abs(rho_fin-rho)]),0.2);
    rho=rho+delta;
    X0=V(1:4);  
    X=V(5:end);
    X=reshape(X,6,Mgamma-1);
    aold=[X0(2:end),[X(1,:);X(3,:);X(5,:)]];
    bold=[ [0;0;0], [X(2,:);X(4,:);X(6,:)]];
    ris=newton_orbit_lorenz(V,aold,bold,power);
    V=ris;
end
