function [B,Pk]=integration_floquet_lorenz_complex(m)



global rho sigma beta gamma_0 gamma_k T 

options=odeset('AbsTol',1e-14,'RelTol',1e-10);
    sol_ini=gamma_0;
    sol_ini=sol_ini+2*sum(real(gamma_k),2);
    
  
M=lor_monodromyT;                                                         % first guess for the monodromy matrix
B=logm(M)/(T);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% integration of f'=Jac(gamma(t))*f-f*R, f(0)=I
inispace=sol_ini;
ini_P=eye(3);
ini=[inispace;reshape(ini_P,9,1)];

[t,y]=ode45(@systemPR,[0,T],ini,options);       

N=length(t);

Comp=fft(y(:,4:end))/N;

for j=1:m
    Pk(:,:,j)=reshape(Comp(j,:),3,3);
end
m=size(Pk,3)-1;
Pk=cat(3,conj(Pk(:,:,end:-1:2)),Pk);

clear Comp

function Mon=lor_monodromyT
                        
        Id=eye(3);
        ini=[sol_ini;reshape(Id,[],1)];
        [t,y]=ode45(@systemMonodromy,[0 T],ini,options);   % integrate linearized system   
        Mon=reshape(y(end,4:end),3,3);                     % monodromy matrix
        
        
        function df=systemMonodromy(t,x)
            
            Mon=reshape(x(4:end),3,3);            
            J=[-sigma, sigma, 0;...
                rho-x(3), -1, -x(1);...
                x(2), x(1),-beta];
                        
            
            df(1,1)=sigma*(x(2)-x(1));
            df(2,1)=rho*x(1)-x(2)-x(1)*x(3);
            df(3,1)=x(1)*x(2)-beta*x(3);
            dfM=J*Mon;
            df=[df;reshape(dfM,9,1)];
            
        end
        
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    function df=systemPR(t,x)
        
        f=reshape(x(4:end),3,3);
        
        J=[-sigma, sigma, 0;...
            rho-x(3), -1, -x(1);...
            x(2), x(1),-beta];
        
        df(1,1)=sigma*(x(2)-x(1));
        df(2,1)=rho*x(1)-x(2)-x(1)*x(3);
        df(3,1)=x(1)*x(2)-beta*x(3);
        dff=J*f-f*B;
        df=[df;reshape(dff,9,1)];
    end
end
