' Computing Paramterization of Invariant Manifolds'

clear all;
which_system=input('Please select the system: 1 Lorenz, 2 Arneodo, 3 Kuramoto-Sivashinsky:');

if which_system==1
    system='Lorenz';
elseif which_system==2
    system='Arneodo';
elseif which_system==3
    system='KS';
end
 cd(strcat(system, '_folder'));
 run(strcat('Main_',system,'_complex'));
 cd ..
 

[B,Pk]=newton_floquet_complex(Ak,B,Pk);
Lambda=eigs(B);

if mode=='2T'
    Pk(:,:,1:m-1)=flipdim(conj(Pk(:,:,m+1:end)),3);
    Pk(:,:,m)=real(Pk(:,:,m));
end
%Pk contains the Fuorier Coeffi. of P(t), Pk(:,:,k)= Q_k with k=-m...m
if isempty(B)==1
    return
end

disp('Newton scheme ended');
gamma=[flipdim(conj(gamma_k),2),gamma_0,gamma_k];

disp('Computing the Parametrization');
[alphas, lambda] = manifold_complex2dim_scaleEigs(gamma,T,Pk,B,m_manifold,N_manifold,stability,D2,dim_man,scaleEigs);


 
N_manifold
m_manifold
disp('DONE !')
disp('Call orbit to see the Fourier coefficients of the peirodic orbit')
disp('Call B to see the exponential matrix of the Floquet Normal form')
disp('Call Pk to see the Fourier coefficients of the matrix function P(t) of the Floquet normal form')
disp('Call Lambda to see the eigenvalues of the matrix B')
disp('Call alphas to see the coefficients of the parametrization')

% If dimension of manifold is 1 
if which_system == 1 || which_system == 2
    if dim_man==1
        Par=plot_parametrization_complex(T,alphas,mode);
    end
end

% In case of Kuramoto-Sivashinsky
%Al=[];
%for j=1:size(alphas,2)
%    Al(j).fc=alphas(j).fc(1:3,:);
%end
%Par=plot_parametrization_complex(T,Al,mode);