function Par=plot_parametrization_complex(T,a,mode)

% ris is the data of the orbit
% a is the structure of the parametrization
% a.n   a(n).fc Fourier coefficient of a^(n-1)(t) on the tau periodic basis
% n=1....N


S=size(a(1).fc);

m=(S(2)-1)/2;  %number of Four. coefficients for any a_n
dimN=S(1);

N=size(a,2)-1;

 thetas=linspace(0,T,200);    

% fourier coefficients of the periodic orbit
gamma_k=a(1).fc;   

% orbit in time space
gamma=zeros(dimN,length(thetas));
for k=-m:m
    expk=exp(1i*k*2*pi/T*thetas);
    gamma=gamma+gamma_k(:,m+1+k)*expk;
    
end
if max(max(imag(gamma)))<10^-14
    gamma=real(gamma);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

an=[];
norm_an=[];
for j=1:N                   % each aj(t) in time space (theta space)
    an_k=a(j+1).fc;          
    a_ntheta=zeros(dimN,length(thetas));
    for k=-m:m
        expk=exp(1i*k*2*pi/T*thetas);
        a_ntheta=a_ntheta+an_k(:,m+1+k)*expk;
    end
    an=cat(3,an,a_ntheta);
    norm_an=[norm_an,(max(sum(a_ntheta.^2,1).^(1/2)))^(1/j)];
end
Sigma=min(1./real(norm_an(3:end)));
%Sigma=0.35;
if mode=='2T'
sigma=linspace(-0*Sigma,1*Sigma,17); 
else
    sigma=linspace(-1*Sigma,1*Sigma,21); 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%


Par=[];                    % Parametrization
for st=1:length(sigma)     % steps of sigma
    sigmast=sigma(st);
    par=gamma;
    for j=1:N
        par=par+an(:,:,j)*sigmast^j;
    end
    Par=cat(3,Par,par);
end

Par=real(Par);


f1=figure(1);
hold on
cmap=colormap(autumn(size(Par,3)));
cmap=colormap(winter(size(Par,3)));


for j=1:size(Par,3)-1
for i=1:size(Par,2)-1
    V=[Par(:,i,j)'; Par(:,i+1,j)';Par(:,i+1,j+1)'; Par(:,i,j+1)'];
    Fac=[1,2,3,4];
hold on
patch('vertices',V,'faces',Fac,'facecolor',cmap(j,:),'Edgecolor',cmap(j,:),'FaceAlpha',0.7);%,'FaceLighting','phong');
end
end

plot3(gamma(1,:),gamma(2,:),gamma(3,:),'k','Linewidth',2);
axis equal

figure(2)


cmap=colormap(autumn(size(Par,3)));


for j=1:size(Par,3)
     plot3(Par(1,:,j),Par(2,:,j),Par(3,:,j),'color',cmap(j,:));
     hold on
end

plot3(gamma(1,:),gamma(2,:),gamma(3,:),'k','Linewidth',2);
axis equal
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


